:: Licensed Materials - Property of IBM
::
:: Runs a batch file and returns its error code to the calling process.  This is necessary
:: since some batch files return using the /B flag and cannot be modified, thus the error
:: code is lost and the calling process believes the batch file completed successfully.
::
:: e.g. If Ant calls a batch file that exits with the /B flag, Ant will continue, noting a
:: 		successful build, when in fact, this may not be the case.
::
:: Usage: batchWrapper.bat <batch file to run> <arg1> <arg2> ...

@echo off

set BATCH_FILE=%1
shift

set PARAMS=

: GET_PARAMS
if '%1'=='' goto RUN_BATCH
	set PARAMS=%PARAMS% %1
	shift
goto GET_PARAMS

:RUN_BATCH
pushd %~dp0
call %BATCH_FILE% %PARAMS%
popd
exit %ERRORLEVEL%