dojo.provide("com.ibm.pb.dnd.layout.LayoutControlAvatar");

dojo.declare("com.ibm.pb.dnd.layout.LayoutControlAvatar", dojo.dnd.Avatar, {
	construct: function(){
		// summary: constructs the avatar for portlets
		var div = dojo.doc.createElement("div");
		div.style.position = "absolute";
		div.style.zIndex = 1999;
		div.style.margin = "0px";
		var source = this.manager.source, node;
		// create an avatar representation of the node
		// Portal only allows 1 portlet to be dragged, 
		// so it is known to use only the first item in the array
		_temp = source._normalizedCreator(source.getItem(this.manager.nodes[0].id).data, "avatar");
		node = _temp.node;
		node.id = "";
		dojo.style(div, "opacity", 0.5);
		div.appendChild(node);
		this.node = div;
	},
	
	//override default one
	update: function(){
		
		// summary:
		//		updates the avatar to reflect the current DnD state
		
		//comment following line to improve the performance
		//dojo[(this.manager.canDropFlag ? "add" : "remove") + "Class"](this.node, "dojoDndAvatarCanDrop");
		
		if (this.isA11y){
			var icon = dojo.byId("a11yIcon");
			var text = '+';   // assume canDrop && copy
			if (this.manager.canDropFlag && !this.manager.copy) {
				text = '< '; // canDrop && move 
			}else if (!this.manager.canDropFlag && !this.manager.copy) {
				text = "o"; //!canDrop && move
			}else if(!this.manager.canDropFlag){
				text = 'x';  // !canDrop && copy
			}
			icon.innerHTML=text;
		}
		// replace text
		dojo.query(("tr.dojoDndAvatarHeader td span" +(this.isA11y ? " span" : "")), this.node).forEach(
			function(node){
				node.innerHTML = this._generateText();
			}, this);
	}
});
