dojo.provide("com.ibm.pb.layout.filters.RowContainerStyleFilter");
dojo.require("com.ibm.pb.layout.filters.ContainerStyleFilter");
dojo.declare("com.ibm.pb.layout.filters.RowContainerStyleFilter", [com.ibm.pb.layout.filters.ContainerStyleFilter], {
	// corresponds to a row container type
	
    _filterStyle: function(layoutNode, node, oldStyle, newStyle) {
		if (this._isControl(layoutNode)) {
			// resize widget
			// widgets in rows cannot change height, it should be fluid
			if (newStyle.height){
				delete newStyle.height;
			}
			// make sure widget is not too wide (ie: extends beyond its container)
			var maxWidth = dojo.contentBox(node.parentNode).w;
			if (parseInt(newStyle.width) > maxWidth) {
				newStyle.width = maxWidth + "px";
			}
			// make sure the widget is not too thin
			if (parseInt(newStyle.width) < this.widgetMinWidth) {
				newStyle.width = this.widgetMinWidth + "px";
			}
		} else if (this._isContainer(layoutNode)) {
			// resizer container
			if(parseInt(newStyle.width) < this.containerMinWidth){
				newStyle.width = this.containerMinWidth+"%";
			}
		}
	},
	_isAgree: function(layoutNode, node, oldStyle, newStyle) {
		// summary: return true if the new style is allowed, false otherwise
		if (this._isContainer(layoutNode)) {
			if(parseInt(newStyle.width) < this.containerMinWidth){
				return false;
			}
		}
		return true;
	}
});
