/* Copyright IBM Corp. 2013  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.DeferredIterator");

dojo.require("com.ibm.mashups.enabler.Deferred");
dojo.require("com.ibm.mashups.enabler.Iterator");
//<INTERFACE>
/**
 * The DeferredIterator can be used to iterate over a list of objects
 * in an asynchronous fashion. The callback handler is called as
 * soon as the next object has been loaded.
 * The start method is only used for the asynchronous aspect of
 * the deferred iterator. For the synchronous aspect the methods
 * such as hasNext() can be called directly.
 * @ibm-api
 * @ibm-module Base
 */
dojo.declare("com.ibm.mashups.enabler.DeferredIterator", [com.ibm.mashups.enabler.Deferred, com.ibm.mashups.enabler.Iterator], {

    /**
     * Sets the handler of the deferred action. It is called when the
     * next object in the list has been loaded and is ready to be processed.
     * @param {Object} callback the callback funtion in the format of <code>Function(object nextElement, Object[] params)</code>. Must not be <code>null</code><br>
     * &nbsp;&nbsp;&nbsp;&nbsp;<b>Callbackparameters</b><br/>
     * &nbsp;&nbsp;&nbsp;&nbsp;<code>nextElement</code> - the next
     * object in the list<br/>
     * &nbsp;&nbsp;&nbsp;&nbsp;<code>params</code> - the parameters
     * passed into the addForEachCallback
     * @param {Object[]} parameters optional array of parameters to be
     * passed on to the callback function
     * @return {com.ibm.mashups.enabler.DeferredIterator} the deferred object
     */
    setForEachCallback: function(callback, parameters){
    }
});
//</INTERFACE>

dojo.require("com.ibm.mm.enabler.DeferredIteratorImpl");
