/* Copyright IBM Corp. 2013  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.layout.LayoutControl");

//<INTERFACE>
dojo.require("com.ibm.mashups.enabler.layout.LayoutNode");
dojo.require("com.ibm.mashups.enabler.ModifiableLocalized");
dojo.require("com.ibm.mashups.enabler.content.RuntimeContentProvider");

/**
 * Interface for a control. A control holds a widget by referencing its instance.
 *
 * @since 2.4
 *
 * @ibm-api
 * @ibm-module LayoutModel
 */
dojo.declare("com.ibm.mashups.enabler.layout.LayoutControl", [com.ibm.mashups.enabler.layout.LayoutNode, com.ibm.mashups.enabler.ModifiableLocalized, com.ibm.mashups.enabler.content.RuntimeContentProvider], {

    /**
     * Returns the skin used by this control.
     * @return {com.ibm.mashups.enabler.Identifiable} id of the skin, or
     * <code>null</code> if no skin is defined for this control.
     */
    getSkin: function(){
        throw new Error('Unimplemented API: com.ibm.mashups.enabler.layout.LayoutControl.getSkin');
    },
    
    /**
     * Sets the skin to be used by this control.
     * @param {com.ibm.mashups.enabler.Identifiable} id id of the skin to set
     * @return {void}
     */
    setSkin: function(id){
        throw new Error('Unimplemented API: com.ibm.mashups.enabler.layout.LayoutControl.setSkin');
    },
     
    /**
     * Returns the widget body markup (w/o Skin)
     * 
     * @since 3.0
     * @ibm-spi
     */
    getWidgetBody: function() {
    	
    }
});
//</INTERFACE>

dojo.require("com.ibm.mm.enabler.layout.LayoutControlImpl");

