/* Copyright IBM Corp. 2013  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.iwidget.services.WidgetEventModelFactoryService");

//<INTERFACE>
/**
 * @private
 * @ibm-module iWidget
 */
dojo.declare("com.ibm.mashups.iwidget.services.WidgetEventModelFactoryService",null,  {
	
	/**
	 * TODO make this public at some point, ServiceManager documentation says it should be there
	 * 
	 * @private
	 */
	SERVICE_NAME : "WidgetEventModelFactoryService",
	
    /**
     * Creates event model for the specified widget by honoring the current persistence mode (e.g. DOM vs. Model).
     * The factory for the current persistence mode needs to be added to this service by using the <tt>addFactory</tt> method of this class.
     * 
     * @param {com.ibm.mashups.iwidget.widget.IWidgetWrapper} widget the widget for which to create the event model
     * @return {com.ibm.mashups.Deferred} an event model (com.ibm.mashups.iwidget.model.EventModel) for the specified widget using the according factory or <tt>null</tt> if no factory is available for the current mode.
     */
    createEventModel: function(widgetWrapper,contextAndCallback) {
        
    },
    /**
     * Sets the factory for the specified persistenceMode to this service.
     * @param {String} persistenceMode the mode that is supported by the specified factory
     * @param {com.ibm.mashups.iwidget.services.WidgetEventModelFactory} factory the factory that creates the attributes.
     * @return {void}
     */
    setFactory: function(persistenceMode, factory) {
        
    },
    
    /**
    * Removes a factory for a specified persistence mode.
    * 
    * @param {String} persistenceMode the mode to remove
    * 
    * TODO make this public at some time
    * @private
    */
   removeFactory: function(persistenceMode) {
   	
   }    
});
//</INTERFACE>

// make sure we can reference this globally
com.ibm.mashups.iwidget.services.WidgetEventModelFactoryService.SERVICE_NAME = com.ibm.mashups.iwidget.services.WidgetEventModelFactoryService.prototype.SERVICE_NAME;

dojo.require("com.ibm.mm.iwidget.services.WidgetEventModelFactoryServiceImpl");
